// -*- C++ -*-
//
//  This file is part of Siena, a wide-area event notification system.
//  See http://www.inf.usi.ch/carzaniga/siena/
//
//  Authors: Antonio Carzaniga
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2002 University of Colorado
//
//  Siena is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//  
//  Siena is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with Siena.  If not, see <http://www.gnu.org/licenses/>.
//
#ifndef SIENA_BITCOUNTER_H
#define SIENA_BITCOUNTER_H

namespace siena {

extern const unsigned char	BitCounterMap [];
const unsigned char		BitCounterMapMask = 255;
const unsigned char		BitCounterMapShift = 8;

template <class T>
unsigned char bit_count(T x) {
    register unsigned char res = 0;
    while(x) {
	res += BitCounterMap[reinterpret_cast<unsigned char>(x & BitCounterMapMask)];
	x >>= BitCounterMapShift;
    }
    return res;
}

} // end namespace siena

#endif
